/*--------------------------------------------------------------------------
**  PsGees.tst
**
**  Program for testing DLL files with Dgees and Zgees from LAPACK.
**
**
**
**
**  Paul Soderlind, 20 March 1998
----------------------------------------------------------------------------*/

output file = PsGees.out reset;

dlibrary -a PszGees,PsdGees;

#include PsGees.prc;
/*-----------------------------------------------------------------------*/



A = {  0   1    2,
       1   2   -1,
       1   1    2 };

A = {  3   8,
      -2   3 };      /*Golub and van Loan (1996), p. 313*/


format 8,5;
"\lA ";A;
/*-----------------------------------------------------------------------*/


"\l---------------- Complex Schur -------------------------------";
GtIt = 0;
"\lGtIt: ";;GtIt;
{ T,Q,lambda }    = zGees( A,1.005,GtIt );
"lambda~abs(lambda): ";;lambda~abs(lambda);
"maxc(maxc(abs(Q*T*Q' - A)))   : ";;maxc(maxc(abs(Q*T*Q' - A)));
"T: ";;T;
"Q: ";;Q;

GtIt = 1;
"\lGtIt: ";;GtIt;
{ T,Q,lambda }    = zGees( A,1.005,GtIt );
"lambda~abs(lambda): ";;lambda~abs(lambda);
"maxc(maxc(abs(Q*T*Q' - A)))   : ";;maxc(maxc(abs(Q*T*Q' - A)));
"T: ";;T;
"Q: ";;Q;

"\l---------------- Real Schur -------------------------------";
GtIt = 0;
"\lGtIt: ";;GtIt;
{ T,Q,lambda } = dGees( A,1.005,GtIt );
"lambda~abs(lambda): ";;lambda~abs(lambda);
"maxc(maxc(abs(Q*T*Q' - A)))   : ";;maxc(maxc(abs(Q*T*Q' - A)));
"T: ";;T;
"Q: ";;Q;


GtIt = 1;
"\lGtIt: ";;GtIt;
{ T,Q,lambda } = dGees( A,1.005,GtIt );
"lambda~abs(lambda): ";;lambda~abs(lambda);
"maxc(maxc(abs(Q*T*Q' - A)))   : ";;maxc(maxc(abs(Q*T*Q' - A)));
"T: ";;T;
"Q: ";;Q;
/*-----------------------------------------------------------------------*/

dlibrary -d;
end;

