/*--------------------------------------------------------------------------
**  PsTgSen.tst
**
**  Program for testing DLL files with Dtgsen and Ztgsens from LAPACK.
**

**
**
**
**
**
**  Paul Soderlind, 8 April 1998
----------------------------------------------------------------------------*/

BIit = 0;              /*1: B=eye; else B is as coded below*/


output file = PsTgSen.out reset;

dlibrary -a PszTgSen,PsdTgSen;
#include PsTgSen.prc;
/*-----------------------------------------------------------------------*/

"\lGeneralized eigenvalue problem: A*x=B*lambda*x";

A = {  0   1    2,
       1   2   -1,
       1   1    2 };

B = {  1   2    3,
       4   5    6,
       7   8    9.001 };

if BIit == 1;
	"\lComparison with standard eigenvalue problem: A*x=lambda*x, set B=I";
	B = eye(rows(A));
endif;



format 8,5;
"\lA: ";A;
"\lB: ";B;
/*-----------------------------------------------------------------------*/



"\l\l----------------------- Generalized Schur -----------------------------";
pii_sii = 1;
GtIt = 0;
"\lpii_sii and GtIt: ";;pii_sii~GtIt;


{ S,P,Q,Z,lambda } = zTgSen( A,B,1.01,pii_sii,GtIt );
"\llambda and abs(lambda)"; lambda~abs(lambda);
"\lCompare with diag(S)./diag(P): ";;diag(S)./diag(P);

"\lS: ";;S;
"\lP: ";;P;
"\lQ: ";;Q;
"\lZ: ";;Z;
"\labs(Q*S*Z' - A): ";; abs( Q*S*Z' - A );
"\labs(Q*P*Z' - B): ";; abs( Q*P*Z' - B );
"\labs(Q'A*Z  - S): ";; abs( Q'A*Z   - S );
"\labs(Q'B*Z  - P): ";; abs( Q'B*Z   - P );

"\l----------------------------------------";
pii_sii = 1;
GtIt = 1;
"\lpii_sii and GtIt: ";;pii_sii~GtIt;
{ S,P,Q,Z,lambda } = zTgSen( A,B,1.01,pii_sii,GtIt );
"\llambda and abs(lambda)"; lambda~abs(lambda);


"\l----------------------------------------";
pii_sii = 0;
GtIt = 0;
"\lpii_sii and GtIt: ";;pii_sii~GtIt;
{ S,P,Q,Z,lambda } = zTgSen( A,B,1.01,pii_sii,GtIt );
"\llambda and abs(lambda)"; lambda~abs(lambda);

"\l----------------------------------------";
pii_sii = 0;
GtIt = 1;
"\lpii_sii and GtIt: ";;pii_sii~GtIt;
{ S,P,Q,Z,lambda } = zTgSen( A,B,1.01,pii_sii,GtIt );
"\llambda and abs(lambda)"; lambda~abs(lambda);
/*-----------------------------------------------------------------------*/


"\l\l------------------- Real Generalized Schur -----------------------------";
pii_sii = 1;
GtIt = 0;
"\lpii_sii and GtIt: ";;pii_sii~GtIt;
{ S,P,Q,Z,lambda } = dTgSen( A,B,1.01,pii_sii,GtIt );
"\llambda and abs(lambda)"; lambda~abs(lambda);
"\lCompare with diag(S)./diag(P): ";;diag(S)./diag(P);
"\lNote: the generalized eigenvalues are NOT sii/pii for the real";
"generalized Schur decomposition - if there are repeated roots";
"\lS: ";;S;
"\lP: ";;P;
"\lQ: ";;Q;
"\lZ: ";;Z;

"\labs(Q*S*Z' - A): ";; abs( Q*S*Z' - A );
"\labs(Q*P*Z' - B): ";; abs( Q*P*Z' - B );
"\labs(Q'A*Z  - S): ";; abs( Q'A*Z   - S );
"\labs(Q'B*Z  - P): ";; abs( Q'B*Z   - P );

"\l----------------------------------------";
pii_sii = 1;
GtIt = 1;
"\lpii_sii and GtIt: ";;pii_sii~GtIt;
{ S,P,Q,Z,lambda } = dTgSen( A,B,1.01,pii_sii,GtIt );
"\llambda and abs(lambda)"; lambda~abs(lambda);

"\l----------------------------------------";
pii_sii = 0;
GtIt = 0;
"\lpii_sii and GtIt: ";;pii_sii~GtIt;
{ S,P,Q,Z,lambda } = dTgSen( A,B,1.01,pii_sii,GtIt );
"\llambda and abs(lambda)"; lambda~abs(lambda);

"\l----------------------------------------";
pii_sii = 0;
GtIt = 1;
"\lpii_sii and GtIt: ";;pii_sii~GtIt;
{ S,P,Q,Z,lambda } = dTgSen( A,B,1.01,pii_sii,GtIt );
"\llambda and abs(lambda)"; lambda~abs(lambda);
/*-----------------------------------------------------------------------*/

dlibrary -d;
end;

